## wxFTP

wxFTP can be used to establish a connection to an FTP server and perform all the usual operations. Please consult the RFC 959 for more details about the FTP protocol.

To use a commands which doesn't involve file transfer (i.e. directory oriented commands) you just need to call a corresponding member function or use the generic SendCommand method. However to actually transfer files you just get or give a stream to or from this class and the actual data are read or written using the usual stream methods.

Example of using wxFTP for file downloading:

        wxFTP ftp;

        // if you don't use these lines anonymous login will be used
        ftp.SetUser("user");
        ftp.SetPassword("password");

        if ( !ftp.Connect("ftp.wxwindows.org") )
        {
            wxLogError("Couldn't connect");
            return;
        }

        ftp.ChDir("/pub");
        wxInputStream *in = ftp.GetInputStream("wxWindows-4.2.0.tar.gz");
        if ( !in )
        {
            wxLogError("Coudln't get file");
        }
        else
        {
            size_t size = in->StreamSize();
            char *data = new char[size];
            if ( !in->Read(data, size) )
            {
                wxLogError("Read error");
            }
            else
            {
                // file data is in the buffer
                ...
            }

            delete [] data;
            delete in;
        }

To upload a file you would do (assuming the connection to the server was opened successfully):

            wxOutputStream *out = ftp.GetOutputStream("filename");
            if ( out )
            {
                out->Write(...); // your data
                delete out;
            }

Constants

wxFTP defines constants corresponding to the two supported transfer modes:

    enum TransferMode
    {
        ASCII,
        BINARY
    };

Derived from

wxProtocol

Include files

<wx/protocol/ftp.h>

See also

wxSocketBase

Members

wxFTP::wxFTP
wxFTP::~wxFTP
wxFTP::Abort
wxFTP::CheckCommand
wxFTP::SendCommand
wxFTP::GetLastResult
wxFTP::ChDir
wxFTP::MkDir
wxFTP::RmDir
wxFTP::Pwd
wxFTP::Rename
wxFTP::RmFile
wxFTP::SetAscii
wxFTP::SetBinary
wxFTP::SetTransferMode
wxFTP::SetUser
wxFTP::SetPassword
wxFTP::FileExists
wxFTP::GetFileSize
wxFTP::GetDirList
wxFTP::GetFilesList
wxFTP::GetOutputStream
wxFTP::GetInputStream

### wxFTP::wxFTP

wxFTP()

Default constructor.

### wxFTP::~wxFTP

~wxFTP()

Destructor will close the connection if connected.

### wxFTP::Abort

bool Abort()

Aborts the download currently in process, returns `TRUE` if ok, `FALSE` if an error occured.

### wxFTP::CheckCommand

bool CheckCommand(const wxString& command, char ret)

Send the specified command to the FTP server. ret specifies the expected result.

Return value

TRUE if the command has been sent successfully, else FALSE.

### wxFTP::SendCommand

char SendCommand(const wxString& command)

Send the specified command to the FTP server and return the first character of the return code.

### wxFTP::GetLastResult

const wxString& GetLastResult()

Returns the last command result, i.e. the full server reply for the last command.

### wxFTP::ChDir

bool ChDir(const wxString& dir)

Change the current FTP working directory. Returns TRUE if successful.

### wxFTP::MkDir

bool MkDir(const wxString& dir)

Create the specified directory in the current FTP working directory. Returns TRUE if successful.

### wxFTP::RmDir

bool RmDir(const wxString& dir)

Remove the specified directory from the current FTP working directory. Returns TRUE if successful.

### wxFTP::Pwd

wxString Pwd()

Returns the current FTP working directory.

### wxFTP::Rename

bool Rename(const wxString& src, const wxString& dst)

Rename the specified src element to dst. Returns TRUE if successful.

### wxFTP::RmFile

bool RmFile(const wxString& path)

Delete the file specified by path. Returns TRUE if successful.

### wxFTP::SetAscii

bool SetAscii()

Sets the transfer mode to ASCII. It will be used for the next transfer.

### wxFTP::SetBinary

bool SetBinary()

Sets the transfer mode to binary (IMAGE). It will be used for the next transfer.

### wxFTP::SetTransferMode

bool SetTransferMode(TransferMode mode)

Sets the transfer mode to the specified one. It will be used for the next transfer.

If this function is never called, binary transfer mode is used by default.

### wxFTP::SetUser

void SetUser(const wxString& user)

Sets the user name to be sent to the FTP server to be allowed to log in.

Default value

The default value of the user name is "anonymous".

Remark

This parameter can be included in a URL if you want to use the URL manager. For example, you can use: "ftp://a_user:a_password@a.host:service/a_directory/a_file" to specify a user and a password.

### wxFTP::SetPassword

void SetPassword(const wxString& passwd)

Sets the password to be sent to the FTP server to be allowed to log in.

Default value

The default value of the user name is your email address. For example, it could be "username@userhost.domain". This password is built by getting the current user name and the host name of the local machine from the system.

Remark

This parameter can be included in a URL if you want to use the URL manager. For example, you can use: "ftp://a_user:a_password@a.host:service/a_directory/a_file" to specify a user and a password.

### wxFTP::FileExists

bool FileExists(const wxString& filename)

Returns `TRUE` if the given remote file exists, `FALSE` otherwise.

### wxFTP::GetFileSize

int GetFileSize(const wxString& filename)

Returns the file size in bytes or -1 if the file doesn't exist or the size couldn't be determined. Notice that this size can be approximative size only and shouldn't be used for allocating the buffer in which the remote file is copied, for example.

### wxFTP::GetDirList

bool GetDirList(wxArrayString& files, const wxString& wildcard = "")

The GetList function is quite low-level. It returns the list of the files in the current directory. The list can be filtered using the wildcard string. If wildcard is empty (default), it will return all files in directory.

The form of the list can change from one peer system to another. For example, for a UNIX peer system, it will look like this:

    -r--r--r--   1 guilhem  lavaux      12738 Jan 16 20:17 cmndata.cpp
    -r--r--r--   1 guilhem  lavaux      10866 Jan 24 16:41 config.cpp
    -rw-rw-rw-   1 guilhem  lavaux      29967 Dec 21 19:17 cwlex_yy.c
    -rw-rw-rw-   1 guilhem  lavaux      14342 Jan 22 19:51 cwy_tab.c
    -r--r--r--   1 guilhem  lavaux      13890 Jan 29 19:18 date.cpp
    -r--r--r--   1 guilhem  lavaux       3989 Feb  8 19:18 datstrm.cpp

But on Windows system, it will look like this:

    winamp~1 exe    520196 02-25-1999  19:28  winamp204.exe
            1 file(s)           520 196 bytes

Return value: TRUE if the file list was successfully retrieved, FALSE otherwise.

See also

GetFilesList

### wxFTP::GetFilesList

bool GetFilesList(wxArrayString& files, const wxString& wildcard = "")

This function returns the computer-parsable list of the files in the current directory (optionally only of the files matching the wildcard, all files by default). This list always has the same format and contains one full (including the directory path) file name per line.

Return value: TRUE if the file list was successfully retrieved, FALSE otherwise.

### wxFTP::GetOutputStream

wxOutputStream * GetOutputStream(const wxString& file)

Initializes an output stream to the specified file. The returned stream has all but the seek functionality of wxStreams. When the user finishes writing data, he has to delete the stream to close it.

Return value

An initialized write-only stream.

See also

wxOutputStream

### wxFTP::GetInputStream

wxInputStream * GetInputStream(const wxString& path)

Creates a new input stream on the the specified path. You can use all but the seek functionality of wxStream. Seek isn't available on all streams. For example, http or ftp streams do not deal with it. Other functions like Tell are not available for this sort of stream, at present. You will be notified when the EOF is reached by an error.

Return value

Returns NULL if an error occurred (it could be a network failure or the fact that the file doesn't exist).

Returns the initialized stream. You will have to delete it yourself when you don't need it anymore. The destructor closes the DATA stream connection but will leave the COMMAND stream connection opened. It means that you can still send new commands without reconnecting.

Example of a standalone connection (without wxURL)

      wxFTP ftp;
      wxInputStream *in_stream;
      char *data;

      ftp.Connect("a.host.domain");
      ftp.ChDir("a_directory");
      in_stream = ftp.GetInputStream("a_file_to_get");

      data = new char[in_stream->StreamSize()];

      in_stream->Read(data, in_stream->StreamSize());
      if (in_stream->LastError() != wxStream_NOERROR) {
        // Do something.
      }

      delete in_stream; /* Close the DATA connection */

      ftp.Close(); /* Close the COMMAND connection */

See also

wxInputStream